# Uses of Interface
jdk.incubator.foreign.MemoryAddress

Packages that use MemoryAddress
Package
Description
jdk.incubator.foreign
Classes to support low-level and efficient foreign memory/function access, directly from Java.

## Uses of MemoryAddress in jdk.incubator.foreign

Fields in jdk.incubator.foreign declared as MemoryAddress
Modifier and Type
Field
Description
`static final MemoryAddress`
MemoryAddress.`NULL`
The native memory address instance modelling the `NULL` address.
Methods in jdk.incubator.foreign that return MemoryAddress
Modifier and Type
Method
Description
`MemoryAddress`
MemoryAddress.`addOffset(long offset)`
Creates a new memory address with given offset (in bytes), which might be negative, from current one.
`MemoryAddress`
Addressable.`address()`
Returns the memory address associated with this addressable.
`MemoryAddress`
MemorySegment.`address()`
Returns the base memory address associated with this native memory segment.
`MemoryAddress`
NativeSymbol.`address()`
Returns the memory address associated with this symbol.
`MemoryAddress`
VaList.`address()`
Returns the memory address associated with this variable argument list.
`MemoryAddress`
MemoryAddress.`get(ValueLayout.OfAddress layout, long offset)`
Reads an address from this address and offset with given layout.
`default MemoryAddress`
MemorySegment.`get(ValueLayout.OfAddress layout, long offset)`
Reads an address from this segment and offset with given layout.
`MemoryAddress`
MemoryAddress.`getAtIndex(ValueLayout.OfAddress layout, long index)`
Reads an address from this address and index, scaled by given layout size.
`default MemoryAddress`
MemorySegment.`getAtIndex(ValueLayout.OfAddress layout, long index)`
Reads an address from this segment and index, scaled by given layout size.
`MemoryAddress`
VaList.`nextVarg(ValueLayout.OfAddress layout)`
Reads the next value as a `MemoryAddress` and advances this variable argument list's position.
`static MemoryAddress`
MemoryAddress.`ofLong(long value)`
Obtain a native memory address instance from given long address.
Methods in jdk.incubator.foreign with parameters of type MemoryAddress
Modifier and Type
Method
Description
`static MemorySegment`
MemorySegment.`ofAddress(MemoryAddress address, long bytesSize, ResourceScope scope)`
Creates a new native memory segment with given size and resource scope, and whose base address is the given address.
`static NativeSymbol`
NativeSymbol.`ofAddress(String name, MemoryAddress address, ResourceScope scope)`
Creates a new symbol from given name, address and scope.
`static VaList`
VaList.`ofAddress(MemoryAddress address, ResourceScope scope)`
Constructs a new variable argument list from a memory address pointing to an existing variable argument list, with given resource scope.